<template>
  <div class="sticky sticky_zindex" :class="{ 'sticky-show': isSticky }">
    <header id="header" class="setcion sticky header header-mobile">
      <div class="btn_control_menu">
        <svg class="icon-svg">
          <use xlink:href="/css/images/icons/icon.svg#hamburger" />
        </svg>
      </div>
      <nuxt-link class="img_logo" to="/">
        <img src="/css/images/graphics/logo.svg" alt="thinkpro" />
      </nuxt-link>
      <div class="header__right">
        <button id="auto_search_button" type="submit">
          <svg-icon name="search"></svg-icon>
        </button>
        <a class="close-search">
          <svg class="icon-svg">
            <use xlink:href="/css/images/icons/icon.svg#close" />
          </svg>
        </a>
        <div class="block_search section">
          <form id="search" class="search" action method="get">
            <input
              v-model="search"
              class="fs-stxt onclick-togle search-input"
              type="text"
              placeholder="Tìm kiếm trên ThinkPro"
              autocomplete="off"
              maxlength="50"
              @keyup.enter.prevent="searchIt"
            />
            <button
              type="submit"
              class="search-button"
              @click.prevent="searchIt"
            >
              <svg class="icon-svg">
                <use xlink:href="/css/images/icons/icon.svg#search" />
              </svg>
            </button>
          </form>
        </div>
        <div class="gio-hang">
          <a id="cart-mobile" href="javascript:;" class="onclick">
            <svg class="icon-svg">
              <use xlink:href="/css/images/icons/icon.svg#cart" />
            </svg>
            <b v-if="cart.length" class="fs-cartic countTotalCart">
              {{ cart.length }}
            </b>
          </a>
          <div class="wrap-fill">
            <div class="title">
              <strong>{{ cart.length }} sản phẩm</strong>
              trong giỏ hàng
              <a href="javascript:;" class="close">×</a>
            </div>
            <ul>
              <template v-if="cart.length > 0">
                <div class="list">
                  <div
                    v-for="productmobile in cart"
                    :key="productmobile.id"
                    class="items"
                  >
                    <div class="ava">
                      <nuxt-link :to="'/' + productmobile.shared_url">
                        <img
                          :src="
                            resizeImage(
                              baseImageUrl + productmobile.thumbnail,
                              60,
                              60
                            )
                          "
                        />
                      </nuxt-link>
                    </div>
                    <div class="content">
                      <h3>
                        <nuxt-link :to="'/' + productmobile.shared_url">
                          {{ productmobile.name }}
                        </nuxt-link>
                      </h3>
                      <span class="prie red">
                        {{
                          (productmobile.sale_price || productmobile.price)
                            | formatNumber
                        }}
                      </span>
                    </div>
                  </div>
                </div>
                <div class="btn-bottom">
                  <nuxt-link
                    to="/gio-hang"
                    class="buy btn"
                    @click.native.stop="hideDownCart()"
                  >
                    Giỏ hàng
                  </nuxt-link>
                </div>
              </template>
              <div v-else class="note">
                Bạn chưa có sản phẩm nào trong giỏ hàng
              </div>
            </ul>
          </div>
        </div>
      </div>
    </header>
    <!--HEADER-->
    <header class="fs-header header-pc sticky">
      <div class="f-hdtop blog">
        <div class="container f-wrap">
          <nuxt-link class="fs-logo" to="/">
            <img src="/css/images/graphics/logo.svg" alt="thinkpro" />
          </nuxt-link>
          <ul class="main-menu">
            <li :class="{ active: currentPath == '/tin-tuc' }">
              <nuxt-link to="/tin-tuc">Tất cả tin tức</nuxt-link>
            </li>
            <li
              v-for="cate in listcate1"
              :key="cate.id"
              :class="{ active: currentPath == '/tin-tuc/' + cate.shared_url }"
            >
              <nuxt-link :to="'/tin-tuc/' + cate.shared_url">
                {{ cate.name }}
              </nuxt-link>
            </li>
            <li>
              <a href="javascript:;">
                <svg-icon
                  name="icon-dotted"
                  style="
                    width: 24px;
                    height: 24px;
                    display: inline-block;
                    vertical-align: middle;
                  "
                ></svg-icon>
              </a>
              <div class="level2">
                <ul>
                  <li v-for="cate2 in listcate2" :key="cate2.id">
                    <nuxt-link :to="'/tin-tuc/' + cate2.shared_url">
                      {{ cate2.name }}
                    </nuxt-link>
                  </li>
                </ul>
              </div>
            </li>
          </ul>
          <ul class="fs-hdmn">
            <client-only>
              <li class="user">
                <a href="javascript:;">
                  <svg class="icon-svg">
                    <use xlink:href="/css/images/icons/icon.svg#user" />
                  </svg>
                </a>
                <div class="wrap-fill">
                  <ul>
                    <template v-if="$auth.loggedIn">
                      <li>
                        <h3>
                          <nuxt-link to="/tai-khoan">
                            <i class="iconfont-user"></i>
                            Tài khoản
                          </nuxt-link>
                        </h3>
                      </li>
                      <li @click.prevent="logout">
                        <h3>
                          <a href="javascript:;">
                            <i class="iconfont-exit1"></i>
                            Đăng xuất
                          </a>
                        </h3>
                      </li>
                    </template>
                    <template v-else class="before-login">
                      <li>
                        <h3>
                          <a
                            class="login"
                            href="javascript:;"
                            @click.prevent="openLoginPopup('login')"
                          >
                            <i class="iconfont-login"></i>
                            Đăng nhập
                          </a>
                        </h3>
                      </li>
                      <li>
                        <h3>
                          <a
                            class="login"
                            href="javascript:;"
                            @click.prevent="openLoginPopup('register')"
                          >
                            <i class="iconfont-login"></i>
                            Tạo tài khoản
                          </a>
                        </h3>
                      </li>
                    </template>
                  </ul>
                </div>
              </li>
            </client-only>
          </ul>
        </div>
      </div>
    </header>
    <!--END HEADER-->
    <Login />
  </div>
</template>

<script>
import Helper from '../assets/config'
import { EventBus } from '~/plugins/bus'

export default {
  name: 'HeaderNews',
  components: {
    Login: () => import('~/components/Auth/Login'),
  },
  async fetch() {
    const { data } = await this.$axios.$get('/header/news/get')
    this.news = data
    const categories = await this.$axios.$get('/article/categories')
    this.categoryNew = categories.data
  },
  data() {
    return {
      user: {},
      isSticky: false,
      search: '',
      news: [],
      isOpenMegamenu: false,
      categoryNew: [],
      current_path: '',
    }
  },
  computed: {
    listcate1() {
      return this.categoryNew.slice(0, 4)
    },
    listcate2() {
      return this.categoryNew.slice(4)
    },
    cart() {
      return this.$store.state.cart
    },
    totalCartMoney() {
      return this.$store.getters.totalMoney
    },
    baseImageUrl() {
      return Helper.baseImageUrl
    },
    currentPath() {
      return this.$route.path
    },
  },
  mounted() {
    window.addEventListener('scroll', this.sticky)
    // eslint-disable-next-line no-console
  },
  methods: {
    searchIt() {
      this.$router.push('/tim-kiem?search=' + this.search)
    },
    resizeImage(url, width, height) {
      return Helper.resizeImage(url, width, height)
    },
    logout() {
      this.$auth.logout()
    },
    openLoginPopup(type) {
      EventBus.$emit('open-modal-login', true)
      if (type === 'register') {
        EventBus.$emit('type-register', true)
      } else {
        EventBus.$emit('type-register', false)
      }
    },
    sticky() {
      if (window.pageYOffset > 72) {
        this.isSticky = true
      } else {
        this.isSticky = false
      }
    },
    hideDownCart() {
      document.querySelector('body').classList.remove('open-header')
      const cartMobile = document.getElementById('cart-mobile')
      if (cartMobile !== null) {
        cartMobile.classList.remove('active')
      }
    },
  },
}
</script>
